---
title: CompositionEvent
slug: Web/API/CompositionEvent
tags:
  - API
  - CompositionEvent
  - DOM
  - Event
  - Reference
---
<div>{{APIRef("DOM Events")}}</div>

<p>The DOM <strong><code>CompositionEvent</code></strong> represents events that occur due to the user indirectly entering text.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("CompositionEvent.CompositionEvent()", "CompositionEvent()")}}</dt>
	<dd>Creates a new <code>CompositionEvent</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties of its parent, {{domxref("UIEvent")}}, and its ancestor — {{domxref("Event")}}.</em></p>

<dl>
	<dt>{{domxref("CompositionEvent.data")}} {{readonlyinline}}</dt>
	<dd>Returns the characters generated by the input method that raised the event; its varies depending on the type of event that generated the <code>CompositionEvent</code> object.</dd>
	<dt>{{domxref("CompositionEvent.locale")}} {{readonlyinline}} {{deprecated_inline}}</dt>
	<dd>Returns the locale of current input method (for example, the keyboard layout locale if the composition is associated with IME).</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods of its parent, {{domxref("UIEvent")}}, and its ancestor — {{domxref("Event")}}.</em></p>

<dl>
	<dt>{{domxref("CompositionEvent.initCompositionEvent()")}} {{deprecated_inline}}</dt>
	<dd>Initializes the attributes of a <code>CompositionEvent</code> object.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('UI Events', '#interface-compositionevent', 'CompositionEvent')}}</td>
			<td>{{Spec2('UI Events')}}</td>
			<td></td>
		</tr>
		<tr>
			<td>{{SpecName('DOM3 Events', '#idl-compositionevent', 'CompositionEvent')}}</td>
			<td>{{Spec2('DOM3 Events')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CompositionEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/Element/compositionstart_event">compositionstart</a></li>
	<li><a href="/en-US/docs/Web/API/Element/compositionend_event">compositionend</a></li>
	<li><a href="/en-US/docs/Web/API/Element/compositionupdate_event">compositionupdate</a></li>
	<li><a href="/en-US/docs/DOM/Event/UIEvent" title="UIEvent">UIEvent</a></li>
	<li><a href="/en-US/docs/DOM/event" title="Event">Event</a></li>
</ul>
